Index: palm/trunk/UTIL/inifor/src/io.f90
===================================================================
--- palm/trunk/UTIL/inifor/src/io.f90	(revision 3178)
+++ palm/trunk/UTIL/inifor/src/io.f90	(revision 3182)
@@ -21,6 +21,17 @@
 ! Current revisions:
 ! -----------------
+! Introduced new PALM grid stretching
+! Updated variable names and metadata for PIDS v1.9 compatibility
+! Improved handling of the start date string
+! Better compatibility with older Intel compilers:
+! - avoiding implicit array allocation with new get_netcdf_variable()
+!   subroutine instead of function
+! Improved command line interface:
+! - Added configuration validation
+! - New options to configure input file prefixes
+! - GNU-style short and long option names
+! - Added version and copyright output
 ! 
-! 
+!
 ! Former revisions:
 ! -----------------
@@ -43,13 +54,42 @@
     USE control
     USE defs,                                                                  &
-        ONLY:  DATE, SNAME, PATH, PI, dp, TO_RADIANS, TO_DEGREES, VERSION
+        ONLY:  DATE, SNAME, PATH, PI, dp, hp, TO_RADIANS, TO_DEGREES, VERSION
     USE netcdf
     USE types
     USE util,                                                                  &
-        ONLY:  reverse, str
+        ONLY:  reverse, str, real_to_str
 
     IMPLICIT NONE
 
+    INTERFACE get_netcdf_variable
+        MODULE PROCEDURE get_netcdf_variable_int
+        MODULE PROCEDURE get_netcdf_variable_real
+    END INTERFACE get_netcdf_variable
+
+    PRIVATE ::  get_netcdf_variable_int, get_netcdf_variable_real
+
  CONTAINS
+
+    SUBROUTINE get_netcdf_variable_int(in_file, in_var, buffer)
+
+       CHARACTER(LEN=PATH), INTENT(IN)         ::  in_file
+       TYPE(nc_var), INTENT(INOUT)             ::  in_var
+       INTEGER(hp), ALLOCATABLE, INTENT(INOUT) ::  buffer(:,:,:)
+
+       INCLUDE 'get_netcdf_variable.inc'
+
+    END SUBROUTINE get_netcdf_variable_int
+
+
+    SUBROUTINE get_netcdf_variable_real(in_file, in_var, buffer)
+
+       CHARACTER(LEN=PATH), INTENT(IN)      ::  in_file
+       TYPE(nc_var), INTENT(INOUT)          ::  in_var
+       REAL(dp), ALLOCATABLE, INTENT(INOUT) ::  buffer(:,:,:)
+
+       INCLUDE 'get_netcdf_variable.inc'
+
+    END SUBROUTINE get_netcdf_variable_real
+
 
     SUBROUTINE netcdf_define_variable(var, ncid)
@@ -59,8 +99,9 @@
 
         CALL check(nf90_def_var(ncid, var % name, NF90_FLOAT,       var % dimids(1:var % ndim), var % varid))
-        CALL check(nf90_put_att(ncid, var % varid, "standard_name", var % standard_name))
         CALL check(nf90_put_att(ncid, var % varid, "long_name",     var % long_name))
         CALL check(nf90_put_att(ncid, var % varid, "units",         var % units))
-        CALL check(nf90_put_att(ncid, var % varid, "lod",           var % lod))
+        IF ( var % lod .GE. 0 )  THEN
+           CALL check(nf90_put_att(ncid, var % varid, "lod",           var % lod))
+        END IF 
         CALL check(nf90_put_att(ncid, var % varid, "source",        var % source))
         CALL check(nf90_put_att(ncid, var % varid, "_FillValue",    NF90_FILL_REAL))
@@ -94,16 +135,10 @@
 !> parameters for the PALM-4U computational grid.
 !------------------------------------------------------------------------------!
-    SUBROUTINE parse_command_line_arguments( start_date, hhl_file,             &
-       soiltyp_file, static_driver_file, input_path, output_file,              &
-       namelist_file, ug, vg, p0, z0, mode )
-
-       CHARACTER(LEN=PATH), INTENT(INOUT)  ::  hhl_file, soiltyp_file,         &
-           static_driver_file, input_path, output_file, namelist_file
-       CHARACTER(LEN=SNAME), INTENT(INOUT) ::  mode
-       REAL(dp), INTENT(INOUT)             ::  ug, vg, p0, z0
-       CHARACTER(LEN=DATE), INTENT(INOUT)  ::  start_date
-
-       CHARACTER(LEN=PATH)     ::  option, arg
-       INTEGER                 ::  arg_count, i
+    SUBROUTINE parse_command_line_arguments( cfg )
+
+       TYPE(inifor_config), INTENT(INOUT) ::  cfg
+
+       CHARACTER(LEN=PATH)                ::  option, arg
+       INTEGER                            ::  arg_count, i
 
        arg_count = COMMAND_ARGUMENT_COUNT()
@@ -111,92 +146,121 @@
 
           ! Every option should have an argument.
-          IF ( MOD(arg_count, 2) .NE. 0 )  THEN
-             message = "Syntax error in command line."
-             CALL abort('parse_command_line_arguments', message)
-          END IF
+          !IF ( MOD(arg_count, 2) .NE. 0 )  THEN
+          !   message = "Syntax error in command line."
+          !   CALL abort('parse_command_line_arguments', message)
+          !END IF
           
           message = "The -clon and -clat command line options are depricated. " // &
              "Please remove them form your inifor command and specify the " // &
              "location of the PALM-4U origin either" // NEW_LINE(' ') // &
-             "   - by setting the namelist parameters 'origin_lon' and 'origin_lat, or'" // NEW_LINE(' ') // &
+             "   - by setting the namelist parameters 'longitude' and 'latitude', or" // NEW_LINE(' ') // &
              "   - by providing a static driver netCDF file via the -static command-line option."
 
-          ! Loop through option/argument pairs.
-          DO i = 1, arg_count, 2
+          i = 1
+          DO WHILE (i .LE. arg_count)
 
              CALL GET_COMMAND_ARGUMENT( i, option )
-             CALL GET_COMMAND_ARGUMENT( i+1, arg )
 
              SELECT CASE( TRIM(option) )
 
-             CASE( '-date' )
-                start_date = TRIM(arg)
+             CASE( '-date', '-d', '--date' )
+                CALL get_option_argument( i, arg )
+                cfg % start_date = TRIM(arg)
 
              ! Elevation of the PALM-4U domain above sea level
-             CASE( '-z0' )
-                READ(arg, *) z0
+             CASE( '-z0', '-z', '--elevation' )
+                CALL get_option_argument( i, arg )
+                READ(arg, *) cfg % z0
 
              ! surface pressure, at z0
-             CASE( '-p0' )
-                READ(arg, *) p0
-
-             ! surface pressure, at z0
-             CASE( '-ug' )
-                READ(arg, *) ug
-
-             ! surface pressure, at z0
-             CASE( '-vg' )
-                READ(arg, *) vg
-
-             ! Domain centre geographical longitude
-             CASE( '-clon' )
+             CASE( '-p0', '-r', '--surface-pressure' )
+                CALL get_option_argument( i, arg )
+                READ(arg, *) cfg % p0
+
+             ! geostrophic wind in x direction
+             CASE( '-ug', '-u', '--geostrophic-u' )
+                CALL get_option_argument( i, arg )
+                READ(arg, *) cfg % ug
+
+             ! geostrophic wind in y direction
+             CASE( '-vg', '-v', '--geostrophic-v' )
+                CALL get_option_argument( i, arg )
+                READ(arg, *) cfg % vg
+
+             ! domain centre geographical longitude and latitude
+             CASE( '-clon', '-clat' )
                 CALL abort('parse_command_line_arguments', message)          
                 !READ(arg, *) lambda_cg
                 !lambda_cg = lambda_cg * TO_RADIANS
-
-             ! Domain centre geographical latitude
-             CASE( '-clat' )
-                CALL abort('parse_command_line_arguments', message)          
                 !READ(arg, *) phi_cg
                 !phi_cg = phi_cg * TO_RADIANS
 
-             CASE( '-path' )
-                 input_path = TRIM(arg)
-
-             CASE( '-hhl' )
-                 hhl_file = TRIM(arg)
-
-             CASE( '-static' )
-                 static_driver_file = TRIM(arg)
-
-             CASE( '-soil' )
-                 soiltyp_file = TRIM(arg)
-
-             CASE( '-o' )
-                output_file = TRIM(arg)
-
-             CASE( '-n' )
-                namelist_file = TRIM(arg)
-
-             ! Initialization mode: 'profile' / 'volume'
-             CASE( '-mode' )
-                mode = TRIM(arg)
-
-                SELECT CASE( TRIM(mode) )
-
-                CASE( 'profile' )
-
-                CASE DEFAULT
-                   message = "Mode '" // TRIM(mode) // "' is not supported. " //&
-                             "Currently, '-mode profile' is the only supported option. " //&
-                             "Select this one or omit the -mode option entirely."
-                   CALL abort( 'parse_command_line_arguments', message ) 
-                END SELECT
+             CASE( '-path', '-p', '--path' )
+                CALL get_option_argument( i, arg )
+                 cfg % input_path = TRIM(arg)
+
+             CASE( '-hhl', '-l', '--hhl-file' )
+                CALL get_option_argument( i, arg )
+                 cfg % hhl_file = TRIM(arg)
+
+             CASE( '-static', '-t', '--static-driver' )
+                CALL get_option_argument( i, arg )
+                 cfg % static_driver_file = TRIM(arg)
+
+             CASE( '-soil', '-s', '--soil-file')
+                CALL get_option_argument( i, arg )
+                 cfg % soiltyp_file = TRIM(arg)
+
+             CASE( '--flow-prefix')
+                CALL get_option_argument( i, arg )
+                 cfg % flow_prefix = TRIM(arg)
+
+             CASE( '--radiation-prefix')
+                CALL get_option_argument( i, arg )
+                 cfg % radiation_prefix = TRIM(arg)
+
+             CASE( '--soil-prefix')
+                CALL get_option_argument( i, arg )
+                 cfg % soil_prefix = TRIM(arg)
+
+             CASE( '--soilmoisture-prefix')
+                CALL get_option_argument( i, arg )
+                 cfg % soilmoisture_prefix = TRIM(arg)
+
+             CASE( '-o', '--output' )
+                CALL get_option_argument( i, arg )
+                cfg % output_file = TRIM(arg)
+
+             CASE( '-n', '--namelist' )
+                CALL get_option_argument( i, arg )
+                cfg % namelist_file = TRIM(arg)
+
+             ! initial condition mode: 'profile' / 'volume'
+             CASE( '-mode', '-i', '--init-mode' )
+                CALL get_option_argument( i, arg )
+                cfg % ic_mode = TRIM(arg)
+
+             ! boundary conditions / forcing mode: 'ideal' / 'real'
+             CASE( '-f', '--forcing-mode' )
+                CALL get_option_argument( i, arg )
+                cfg % bc_mode = TRIM(arg)
+
+             CASE( '--version' )
+                CALL print_version()
+                STOP
+
+             CASE( '--help' )
+                CALL print_version()
+                PRINT *, ""
+                PRINT *, "For a list of command-line options have a look at the README file."
+                STOP
 
              CASE DEFAULT
-                message = "unknown option '" // TRIM(option(2:)) // "'."
+                message = "unknown option '" // TRIM(option) // "'."
                 CALL abort('parse_command_line_arguments', message)
 
              END SELECT
+
+             i = i + 1
 
           END DO
@@ -210,4 +274,75 @@
 
    END SUBROUTINE parse_command_line_arguments
+
+   
+   SUBROUTINE get_option_argument(i, arg)
+      CHARACTER(LEN=PATH), INTENT(INOUT) ::  arg
+      INTEGER, INTENT(INOUT)             ::  i
+
+      i = i + 1
+      CALL GET_COMMAND_ARGUMENT(i, arg)
+
+   END SUBROUTINE
+
+
+   SUBROUTINE validate_config(cfg)
+      TYPE(inifor_config), INTENT(IN) ::  cfg
+      LOGICAL                         ::  all_files_present
+
+      all_files_present = .TRUE.
+      all_files_present = all_files_present .AND. file_present(cfg % hhl_file)
+      all_files_present = all_files_present .AND. file_present(cfg % namelist_file)
+      all_files_present = all_files_present .AND. file_present(cfg % output_file)
+      all_files_present = all_files_present .AND. file_present(cfg % soiltyp_file)
+
+      ! Only check optional static driver file name, if it has been given.
+      IF (TRIM(cfg % static_driver_file) .NE. '')  THEN
+         all_files_present = all_files_present .AND. file_present(cfg % static_driver_file)
+      END IF
+
+      IF (.NOT. all_files_present)  THEN
+         message = "INIFOR configuration invalid; some input files are missing."
+         CALL abort( 'validate_config', message ) 
+      END IF
+      
+      
+      SELECT CASE( TRIM(cfg % ic_mode) )
+      CASE( 'profile', 'volume')
+      CASE DEFAULT
+         message = "Initialization mode '" // TRIM(cfg % ic_mode) //&
+                   "' is not supported. " //&
+                   "Please select either 'profile' or 'volume', " //&
+                   "or omit the -i/--init-mode/-mode option entirely, which corresponds "//&
+                   "to the latter."
+         CALL abort( 'validate_config', message ) 
+      END SELECT
+
+
+      SELECT CASE( TRIM(cfg % bc_mode) )
+      CASE( 'real', 'ideal')
+      CASE DEFAULT
+         message = "Forcing mode '" // TRIM(cfg % bc_mode) //& 
+                   "' is not supported. " //&
+                   "Please select either 'real' or 'ideal', " //&
+                   "or omit the -f/--forcing-mode option entirely, which corresponds "//&
+                   "to the latter."
+         CALL abort( 'validate_config', message ) 
+      END SELECT
+
+
+   END SUBROUTINE validate_config
+
+
+   LOGICAL FUNCTION file_present(filename)
+      CHARACTER(LEN=PATH), INTENT(IN) ::  filename
+
+      INQUIRE(FILE=filename, EXIST=file_present)
+
+      IF (.NOT. file_present)  THEN
+         message = "The given file '" // "' does not exist."
+         CALL report('file_present', message)
+      END IF
+
+   END FUNCTION file_present
 
 
@@ -222,15 +357,29 @@
 !> writes the actual data.
 !------------------------------------------------------------------------------!
-    SUBROUTINE setup_netcdf_dimensions(output_file, palm_grid)
+   SUBROUTINE setup_netcdf_dimensions(output_file, palm_grid,                  &
+                                      start_date_string, origin_lon, origin_lat)
 
        TYPE(nc_file), INTENT(INOUT)      ::  output_file
        TYPE(grid_definition), INTENT(IN) ::  palm_grid
-
-       CHARACTER (LEN=SNAME) ::  date
+       CHARACTER (LEN=DATE), INTENT(IN)  ::  start_date_string
+       REAL(dp), INTENT(IN)              ::  origin_lon, origin_lat
+
+       CHARACTER (LEN=8)     ::  date_string
+       CHARACTER (LEN=10)    ::  time_string
+       CHARACTER (LEN=5)     ::  zone_string
+       CHARACTER (LEN=SNAME) ::  history_string
        INTEGER               ::  ncid, nx, ny, nz, nt, dimids(3), dimvarids(3)
        REAL(dp)              ::  z0
 
+       message = "Initializing PALM-4U dynamic driver file '" //               &
+                 TRIM(output_file % name) // "' and setting up dimensions."
+       CALL report('setup_netcdf_dimensions', message)
+
        ! Create the NetCDF file. NF90_CLOBBER selects overwrite mode.
+#if defined( __netcdf4 )
        CALL check(nf90_create(TRIM(output_file % name), OR(NF90_CLOBBER, NF90_HDF5), ncid))
+#else
+       CALL check(nf90_create(TRIM(output_file % name), NF90_CLOBBER, ncid))
+#endif
 
 !
@@ -238,13 +387,18 @@
 !- Section 1: Write global NetCDF attributes
 !------------------------------------------------------------------------------
-       CALL date_and_time(date)
+       CALL date_and_time(DATE=date_string, TIME=time_string, ZONE=zone_string)
+       history_string =                                                        &
+           'Created on '// date_string      //                                 &
+           ' at '       // time_string(1:2) // ':' // time_string(3:4) //      &
+           ' (UTC'      // zone_string // ')'
+
        CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'title',          'PALM input file for scenario ...'))
        CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'institution',    'Deutscher Wetterdienst, Offenbach'))
        CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'author',         'Eckhard Kadasch, eckhard.kadasch@dwd.de'))
-       CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'history',        'Created on '//date))
+       CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'history',        TRIM(history_string)))
        CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'references',     '--'))
        CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'comment',        '--'))
-       CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'origin_lat',     '--'))
-       CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'origin_lon',     '--'))
+       CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'origin_lat',     TRIM(real_to_str(origin_lat*TO_DEGREES, '(F18.13)'))))
+       CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'origin_lon',     TRIM(real_to_str(origin_lon*TO_DEGREES, '(F18.13)'))))
        CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'inifor_version', TRIM(VERSION)))
        CALL check(nf90_put_att(ncid, NF90_GLOBAL, 'palm_version',   '--'))
@@ -267,5 +421,5 @@
           CALL check( nf90_def_dim(ncid, "x", nx+1, dimids(1)) )
           CALL check( nf90_def_dim(ncid, "y", ny+1, dimids(2)) )
-          CALL check( nf90_def_dim(ncid, "z", nz+1, dimids(3)) )
+          CALL check( nf90_def_dim(ncid, "z", nz, dimids(3)) )
           output_file % dimids_scl = dimids ! save dimids for later
 
@@ -285,9 +439,9 @@
 
        ! overwrite third dimid with the one of depth
-       CALL check(nf90_def_dim(ncid, "depth", SIZE(palm_grid % depths), dimids(3)) )
+       CALL check(nf90_def_dim(ncid, "zsoil", SIZE(palm_grid % depths), dimids(3)) )
        output_file % dimids_soil = dimids ! save dimids for later
 
        ! overwrite third dimvarid with the one of depth
-       CALL check(nf90_def_var(ncid, "depth", NF90_FLOAT, output_file % dimids_soil(3), dimvarids(3)))
+       CALL check(nf90_def_var(ncid, "zsoil", NF90_FLOAT, output_file % dimids_soil(3), dimvarids(3)))
        CALL check(nf90_put_att(ncid, dimvarids(3), "standard_name", "depth_below_land"))
        CALL check(nf90_put_att(ncid, dimvarids(3), "positive", "down"))
@@ -301,5 +455,5 @@
           CALL check(nf90_def_dim(ncid, "xu", nx, dimids(1)) )
           CALL check(nf90_def_dim(ncid, "yv", ny, dimids(2)) )
-          CALL check(nf90_def_dim(ncid, "zw", nz, dimids(3)) )
+          CALL check(nf90_def_dim(ncid, "zw", nz-1, dimids(3)) )
        output_file % dimids_vel = dimids ! save dimids for later
 
@@ -328,5 +482,6 @@
        CALL check(nf90_put_att(ncid, output_file % dimvarid_time, "standard_name", "time"))
        CALL check(nf90_put_att(ncid, output_file % dimvarid_time, "long_name", "time"))
-       CALL check(nf90_put_att(ncid, output_file % dimvarid_time, "units", "seconds since..."))
+       CALL check(nf90_put_att(ncid, output_file % dimvarid_time, "units",     &
+                               "seconds since " // start_date_string // " UTC"))
 
        CALL check(nf90_enddef(ncid))
@@ -363,5 +518,5 @@
        INTEGER                              ::  i, ncid
 
-       message = "Initializing PALM-4U forcing file '" // TRIM(filename) // "'."
+       message = "Defining variables in dynamic driver '" // TRIM(filename) // "'."
        CALL report('setup_netcdf_variables', message)
 
@@ -374,5 +529,5 @@
 
           IF ( var % to_be_processed )  THEN
-             message = "Defining variable #" // TRIM(str(i)) // " '" // TRIM(var%name) // "'."
+             message = "  variable #" // TRIM(str(i)) // " '" // TRIM(var%name) // "'."
              CALL report('setup_netcdf_variables', message)
 
@@ -386,5 +541,5 @@
        CALL check(nf90_close(ncid))
 
-       message = "Forcing file '" // TRIM(filename) // "' initialized successfully."
+       message = "Dynamic driver '" // TRIM(filename) // "' initialized successfully."
        CALL report('setup_netcdf_variables', message)
 
@@ -447,5 +602,5 @@
 
           input_var => group % in_var_list(1)
-          buffer(buf_id) % array = get_netcdf_variable( input_file, input_var )  
+          CALL get_netcdf_variable(input_file, input_var, buffer(buf_id) % array)
           CALL report('read_input_variables', "Read accumulated " // TRIM(group % in_var_list(1) % name)) 
 
@@ -472,5 +627,5 @@
              END IF
 
-             buffer(ivar) % array = get_netcdf_variable( input_file, input_var )  
+             CALL get_netcdf_variable(input_file, input_var, buffer(ivar) % array)
 
              IF ( input_var % is_upside_down )  CALL reverse(buffer(ivar) % array)
@@ -545,4 +700,5 @@
 
           CALL check(nf90_get_att(ncid, NF90_GLOBAL, TRIM(attribute), attribute_value))
+          CALL check(nf90_close(ncid))
 
        ELSE
@@ -555,90 +711,4 @@
 
     END FUNCTION get_netcdf_attribute
-
-
-
-    FUNCTION get_netcdf_variable(in_file, in_var) RESULT(buffer)
-
-       CHARACTER(LEN=PATH), INTENT(IN)      ::  in_file
-       TYPE(nc_var), INTENT(INOUT)          ::  in_var
-       REAL(dp), ALLOCATABLE                ::  buffer(:,:,:)
-       INTEGER                              ::  i, ncid, start(3)
-
-
-       ! Read in_var NetCDF attributes
-       IF ( nf90_open( TRIM(in_file), NF90_NOWRITE, ncid ) .EQ. NF90_NOERR .AND. &
-            nf90_inq_varid( ncid, in_var % name, in_var % varid ) .EQ. NF90_NOERR )  THEN
-
-          CALL check(nf90_get_att(ncid, in_var % varid, "long_name", in_var % long_name))
-          CALL check(nf90_get_att(ncid, in_var % varid, "units", in_var % units))
-
-          ! Read in_var NetCDF dimensions
-          CALL check(nf90_inquire_variable( ncid, in_var % varid,              &
-                                            ndims  = in_var % ndim,            &
-                                            dimids = in_var % dimids ))
-                                        
-          DO i = 1, in_var % ndim
-             CALL check(nf90_inquire_dimension( ncid, in_var % dimids(i),      &
-                                                name = in_var % dimname(i),    &
-                                                len  = in_var % dimlen(i) ))
-          END DO
-
-          start = (/ 1, 1, 1 /)
-          IF ( TRIM(in_var % name) .EQ. 'T_SO' )  THEN
-             ! Skip depth = 0.0 for T_SO and reduce number of depths from 9 to 8
-             in_var % dimlen(3) = in_var % dimlen(3) - 1
-
-             ! Start reading from second level, e.g. depth = 0.005 instead of 0.0
-             start(3) = 2
-          END IF
-
-          SELECT CASE(in_var % ndim)
-
-          CASE (2)
-
-             ALLOCATE( buffer( in_var % dimlen(1),                             &
-                               in_var % dimlen(2),                             &
-                               1 ) )
-
-          CASE (3)
-
-             ALLOCATE( buffer( in_var % dimlen(1),                             &
-                               in_var % dimlen(2),                             &
-                               in_var % dimlen(3) ) )
-          CASE (4)
-
-             ALLOCATE( buffer( in_var % dimlen(1),                             &
-                               in_var % dimlen(2),                             &
-                               in_var % dimlen(3) ) )
-          CASE DEFAULT
-
-             message = "Failed reading NetCDF variable " //                    &
-                TRIM(in_var % name) // " with " // TRIM(str(in_var%ndim)) //   &
-                " dimensions because only two- and and three-dimensional" //   &
-                " variables are supported."
-             CALL abort('get_netcdf_variable', message) 
-
-          END SELECT
- CALL run_control('time', 'alloc')
-          
-          ! TODO: Check for matching dimensions of buffer and var
-          CALL check(nf90_get_var( ncid, in_var % varid, buffer,               &
-                                   start = start,                              &
-                                   count = in_var % dimlen(1:3) ) )
-
- CALL run_control('time', 'read')
-       ELSE
-
-          message = "Failed to read '" // TRIM(in_var % name) // &
-             "' from file '" // TRIM(in_file) // "'."
-          CALL report('get_netcdf_variable', message)
-
-       END IF
-
-       CALL check(nf90_close(ncid))
-
- CALL run_control('time', 'read')
-
-    END FUNCTION get_netcdf_variable
 
 
@@ -657,9 +727,6 @@
 
        ! Skip time dimension for output
-       IF ( var_is_time_dependent )  THEN
-          ndim = var % ndim - 1
-       ELSE 
-          ndim = var % ndim
-       END IF
+       ndim = var % ndim
+       IF ( var_is_time_dependent )  ndim = var % ndim - 1
 
        start(:)      = (/1,1,1,1/)
@@ -733,9 +800,14 @@
                                    start=start(1:ndim+1) ) )
 
-       CASE ( 'profile' )
+       CASE ( 'constant scalar profile' )
 
           CALL check(nf90_put_var( ncid, var%varid, array(1,1,:),              &
                                    start=start(1:ndim+1),                      &
                                    count=count(1:ndim) ) )
+
+       CASE ( 'large-scale scalar forcing', 'large-scale w forcing' )
+
+           message = "Doing nothing in terms of writing large-scale forings."
+           CALL report('update_output', message)
 
        CASE DEFAULT
